import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataCloudflareAccountRolesConfig extends cdktf.TerraformMetaArguments {
    /**
    * The account identifier to target for the resource.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/d/account_roles#account_id DataCloudflareAccountRoles#account_id}
    */
    readonly accountId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/d/account_roles#id DataCloudflareAccountRoles#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
export interface DataCloudflareAccountRolesRoles {
}
export declare function dataCloudflareAccountRolesRolesToTerraform(struct?: DataCloudflareAccountRolesRoles): any;
export declare class DataCloudflareAccountRolesRolesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataCloudflareAccountRolesRoles | undefined;
    set internalValue(value: DataCloudflareAccountRolesRoles | undefined);
    get description(): string;
    get id(): string;
    get name(): string;
}
export declare class DataCloudflareAccountRolesRolesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataCloudflareAccountRolesRolesOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/cloudflare/d/account_roles cloudflare_account_roles}
*/
export declare class DataCloudflareAccountRoles extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "cloudflare_account_roles";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/cloudflare/d/account_roles cloudflare_account_roles} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataCloudflareAccountRolesConfig
    */
    constructor(scope: Construct, id: string, config: DataCloudflareAccountRolesConfig);
    private _accountId?;
    get accountId(): string;
    set accountId(value: string);
    get accountIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _roles;
    get roles(): DataCloudflareAccountRolesRolesList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
