import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataCloudflareIpRangesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/d/ip_ranges#id DataCloudflareIpRanges#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/cloudflare/d/ip_ranges cloudflare_ip_ranges}
*/
export declare class DataCloudflareIpRanges extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "cloudflare_ip_ranges";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/cloudflare/d/ip_ranges cloudflare_ip_ranges} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataCloudflareIpRangesConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataCloudflareIpRangesConfig);
    get chinaIpv4CidrBlocks(): string[];
    get chinaIpv6CidrBlocks(): string[];
    get cidrBlocks(): string[];
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get ipv4CidrBlocks(): string[];
    get ipv6CidrBlocks(): string[];
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
