import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataCloudflareWafGroupsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_groups#id DataCloudflareWafGroups#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_groups#package_id DataCloudflareWafGroups#package_id}
    */
    readonly packageId?: string;
    /**
    * The zone identifier to target for the resource.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_groups#zone_id DataCloudflareWafGroups#zone_id}
    */
    readonly zoneId: string;
    /**
    * filter block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_groups#filter DataCloudflareWafGroups#filter}
    */
    readonly filter?: DataCloudflareWafGroupsFilter;
}
export interface DataCloudflareWafGroupsGroups {
}
export declare function dataCloudflareWafGroupsGroupsToTerraform(struct?: DataCloudflareWafGroupsGroups): any;
export declare class DataCloudflareWafGroupsGroupsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataCloudflareWafGroupsGroups | undefined;
    set internalValue(value: DataCloudflareWafGroupsGroups | undefined);
    get description(): string;
    get id(): string;
    get mode(): string;
    get modifiedRulesCount(): number;
    get name(): string;
    get packageId(): string;
    get rulesCount(): number;
}
export declare class DataCloudflareWafGroupsGroupsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataCloudflareWafGroupsGroupsOutputReference;
}
export interface DataCloudflareWafGroupsFilter {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_groups#mode DataCloudflareWafGroups#mode}
    */
    readonly mode?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_groups#name DataCloudflareWafGroups#name}
    */
    readonly name?: string;
}
export declare function dataCloudflareWafGroupsFilterToTerraform(struct?: DataCloudflareWafGroupsFilterOutputReference | DataCloudflareWafGroupsFilter): any;
export declare class DataCloudflareWafGroupsFilterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflareWafGroupsFilter | undefined;
    set internalValue(value: DataCloudflareWafGroupsFilter | undefined);
    private _mode?;
    get mode(): string;
    set mode(value: string);
    resetMode(): void;
    get modeInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_groups cloudflare_waf_groups}
*/
export declare class DataCloudflareWafGroups extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "cloudflare_waf_groups";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_groups cloudflare_waf_groups} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataCloudflareWafGroupsConfig
    */
    constructor(scope: Construct, id: string, config: DataCloudflareWafGroupsConfig);
    private _groups;
    get groups(): DataCloudflareWafGroupsGroupsList;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _packageId?;
    get packageId(): string;
    set packageId(value: string);
    resetPackageId(): void;
    get packageIdInput(): string | undefined;
    private _zoneId?;
    get zoneId(): string;
    set zoneId(value: string);
    get zoneIdInput(): string | undefined;
    private _filter;
    get filter(): DataCloudflareWafGroupsFilterOutputReference;
    putFilter(value: DataCloudflareWafGroupsFilter): void;
    resetFilter(): void;
    get filterInput(): DataCloudflareWafGroupsFilter | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
