import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataCloudflareWafPackagesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_packages#id DataCloudflareWafPackages#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The zone identifier to target for the resource.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_packages#zone_id DataCloudflareWafPackages#zone_id}
    */
    readonly zoneId: string;
    /**
    * filter block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_packages#filter DataCloudflareWafPackages#filter}
    */
    readonly filter?: DataCloudflareWafPackagesFilter;
}
export interface DataCloudflareWafPackagesPackages {
}
export declare function dataCloudflareWafPackagesPackagesToTerraform(struct?: DataCloudflareWafPackagesPackages): any;
export declare class DataCloudflareWafPackagesPackagesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataCloudflareWafPackagesPackages | undefined;
    set internalValue(value: DataCloudflareWafPackagesPackages | undefined);
    get actionMode(): string;
    get description(): string;
    get detectionMode(): string;
    get id(): string;
    get name(): string;
    get sensitivity(): string;
}
export declare class DataCloudflareWafPackagesPackagesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataCloudflareWafPackagesPackagesOutputReference;
}
export interface DataCloudflareWafPackagesFilter {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_packages#action_mode DataCloudflareWafPackages#action_mode}
    */
    readonly actionMode?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_packages#detection_mode DataCloudflareWafPackages#detection_mode}
    */
    readonly detectionMode?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_packages#name DataCloudflareWafPackages#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_packages#sensitivity DataCloudflareWafPackages#sensitivity}
    */
    readonly sensitivity?: string;
}
export declare function dataCloudflareWafPackagesFilterToTerraform(struct?: DataCloudflareWafPackagesFilterOutputReference | DataCloudflareWafPackagesFilter): any;
export declare class DataCloudflareWafPackagesFilterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflareWafPackagesFilter | undefined;
    set internalValue(value: DataCloudflareWafPackagesFilter | undefined);
    private _actionMode?;
    get actionMode(): string;
    set actionMode(value: string);
    resetActionMode(): void;
    get actionModeInput(): string | undefined;
    private _detectionMode?;
    get detectionMode(): string;
    set detectionMode(value: string);
    resetDetectionMode(): void;
    get detectionModeInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _sensitivity?;
    get sensitivity(): string;
    set sensitivity(value: string);
    resetSensitivity(): void;
    get sensitivityInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_packages cloudflare_waf_packages}
*/
export declare class DataCloudflareWafPackages extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "cloudflare_waf_packages";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_packages cloudflare_waf_packages} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataCloudflareWafPackagesConfig
    */
    constructor(scope: Construct, id: string, config: DataCloudflareWafPackagesConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _packages;
    get packages(): DataCloudflareWafPackagesPackagesList;
    private _zoneId?;
    get zoneId(): string;
    set zoneId(value: string);
    get zoneIdInput(): string | undefined;
    private _filter;
    get filter(): DataCloudflareWafPackagesFilterOutputReference;
    putFilter(value: DataCloudflareWafPackagesFilter): void;
    resetFilter(): void;
    get filterInput(): DataCloudflareWafPackagesFilter | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
