import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataCloudflareWafRulesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_rules#id DataCloudflareWafRules#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_rules#package_id DataCloudflareWafRules#package_id}
    */
    readonly packageId?: string;
    /**
    * The zone identifier to target for the resource.
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_rules#zone_id DataCloudflareWafRules#zone_id}
    */
    readonly zoneId: string;
    /**
    * filter block
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_rules#filter DataCloudflareWafRules#filter}
    */
    readonly filter?: DataCloudflareWafRulesFilter;
}
export interface DataCloudflareWafRulesRules {
}
export declare function dataCloudflareWafRulesRulesToTerraform(struct?: DataCloudflareWafRulesRules): any;
export declare class DataCloudflareWafRulesRulesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataCloudflareWafRulesRules | undefined;
    set internalValue(value: DataCloudflareWafRulesRules | undefined);
    get allowedModes(): string[];
    get defaultMode(): string;
    get description(): string;
    get groupId(): string;
    get groupName(): string;
    get id(): string;
    get mode(): string;
    get packageId(): string;
    get priority(): string;
}
export declare class DataCloudflareWafRulesRulesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataCloudflareWafRulesRulesOutputReference;
}
export interface DataCloudflareWafRulesFilter {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_rules#description DataCloudflareWafRules#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_rules#group_id DataCloudflareWafRules#group_id}
    */
    readonly groupId?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_rules#mode DataCloudflareWafRules#mode}
    */
    readonly mode?: string;
}
export declare function dataCloudflareWafRulesFilterToTerraform(struct?: DataCloudflareWafRulesFilterOutputReference | DataCloudflareWafRulesFilter): any;
export declare class DataCloudflareWafRulesFilterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataCloudflareWafRulesFilter | undefined;
    set internalValue(value: DataCloudflareWafRulesFilter | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _groupId?;
    get groupId(): string;
    set groupId(value: string);
    resetGroupId(): void;
    get groupIdInput(): string | undefined;
    private _mode?;
    get mode(): string;
    set mode(value: string);
    resetMode(): void;
    get modeInput(): string | undefined;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_rules cloudflare_waf_rules}
*/
export declare class DataCloudflareWafRules extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "cloudflare_waf_rules";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/cloudflare/d/waf_rules cloudflare_waf_rules} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataCloudflareWafRulesConfig
    */
    constructor(scope: Construct, id: string, config: DataCloudflareWafRulesConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _packageId?;
    get packageId(): string;
    set packageId(value: string);
    resetPackageId(): void;
    get packageIdInput(): string | undefined;
    private _rules;
    get rules(): DataCloudflareWafRulesRulesList;
    private _zoneId?;
    get zoneId(): string;
    set zoneId(value: string);
    get zoneIdInput(): string | undefined;
    private _filter;
    get filter(): DataCloudflareWafRulesFilterOutputReference;
    putFilter(value: DataCloudflareWafRulesFilter): void;
    resetFilter(): void;
    get filterInput(): DataCloudflareWafRulesFilter | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
